"%%BeginProlog",
"50 dict begin",
"% This is a standard prolog for Postscript generated by Tk's canvas",
"% widget.",
"% SCCS: @(#) prolog.ps 1.5 96/02/17 17:45:11",
"% The definitions below just define all of the variables used in",
"% any of the procedures here.  This is needed for obscure reasons",
"% explained on p. 716 of the Postscript manual (Section H.2.7,",
"% \"Initializing Variables,\" in the section on Encapsulated Postscript).",
"/baseline 0 def",
"/stipimage 0 def",
"/height 0 def",
"/justify 0 def",
"/lineLength 0 def",
"/spacing 0 def",
"/stipple 0 def",
"/strings 0 def",
"/xoffset 0 def",
"/yoffset 0 def",
"/tmpstip null def",
"% Define the array ISOLatin1Encoding (which specifies how characters are",
"% encoded for ISO-8859-1 fonts), if it isn't already present (Postscript",
"% level 2 is supposed to define it, but level 1 doesn't).",
"systemdict /ISOLatin1Encoding known not {\n\
    /ISOLatin1Encoding [\n\
	/space /space /space /space /space /space /space /space\n\
	/space /space /space /space /space /space /space /space\n\
	/space /space /space /space /space /space /space /space\n\
	/space /space /space /space /space /space /space /space\n\
	/space /exclam /quotedbl /numbersign /dollar /percent /ampersand\n\
	    /quoteright\n\
	/parenleft /parenright /asterisk /plus /comma /minus /period /slash\n\
	/zero /one /two /three /four /five /six /seven\n\
	/eight /nine /colon /semicolon /less /equal /greater /question\n\
	/at /A /B /C /D /E /F /G\n\
	/H /I /J /K /L /M /N /O\n\
	/P /Q /R /S /T /U /V /W\n\
	/X /Y /Z /bracketleft /backslash /bracketright /asciicircum /underscore\n\
	/quoteleft /a /b /c /d /e /f /g\n\
	/h /i /j /k /l /m /n /o\n\
	/p /q /r /s /t /u /v /w\n\
	/x /y /z /braceleft /bar /braceright /asciitilde /space\n\
	/space /space /space /space /space /space /space /space\n\
	/space /space /space /space /space /space /space /space\n\
	/dotlessi /grave /acute /circumflex /tilde /macron /breve /dotaccent\n\
	/dieresis /space /ring /cedilla /space /hungarumlaut /ogonek /caron\n\
	/space /exclamdown /cent /sterling /currency /yen /brokenbar /section\n\
	/dieresis /copyright /ordfeminine /guillemotleft /logicalnot /hyphen\n\
	    /registered /macron\n\
	/degree /plusminus /twosuperior /threesuperior /acute /mu /paragraph\n\
	    /periodcentered\n\
	/cedillar /onesuperior /ordmasculine /guillemotright /onequarter\n\
	    /onehalf /threequarters /questiondown\n\
	/Agrave /Aacute /Acircumflex /Atilde /Adieresis /Aring /AE /Ccedilla\n\
	/Egrave /Eacute /Ecircumflex /Edieresis /Igrave /Iacute /Icircumflex\n\
	    /Idieresis\n\
	/Eth /Ntilde /Ograve /Oacute /Ocircumflex /Otilde /Odieresis /multiply\n\
	/Oslash /Ugrave /Uacute /Ucircumflex /Udieresis /Yacute /Thorn\n\
	    /germandbls\n\
	/agrave /aacute /acircumflex /atilde /adieresis /aring /ae /ccedilla\n\
	/egrave /eacute /ecircumflex /edieresis /igrave /iacute /icircumflex\n\
	    /idieresis\n\
	/eth /ntilde /ograve /oacute /ocircumflex /otilde /odieresis /divide\n\
	/oslash /ugrave /uacute /ucircumflex /udieresis /yacute /thorn\n\
	    /ydieresis\n\
    ] def\n\
} if",
"% font ISOEncode font",
"% This procedure changes the encoding of a font from the default",
"% Postscript encoding to ISOLatin1.  It's typically invoked just",
"% before invoking \"setfont\".  The body of this procedure comes from",
"% Section 5.6.1 of the Postscript book.",
"/ISOEncode {\n\
    dup length dict begin\n\
	{1 index /FID ne {def} {pop pop} ifelse} forall\n\
	/Encoding ISOLatin1Encoding def\n\
	currentdict\n\
    end\n\
\n\
    % I'm not sure why it's necessary to use \"definefont\" on this new\n\
    % font, but it seems to be important; just use the name \"Temporary\"\n\
    % for the font.\n\
\n\
    /Temporary exch definefont\n\
} bind def",
"% StrokeClip",
"%",
"% This procedure converts the current path into a clip area under",
"% the assumption of stroking.  It's a bit tricky because some Postscript",
"% interpreters get errors during strokepath for dashed lines.  If",
"% this happens then turn off dashes and try again.",
"/StrokeClip {\n\
    {strokepath} stopped {\n\
	(This Postscript printer gets limitcheck overflows when) =\n\
	(stippling dashed lines;  lines will be printed solid instead.) =\n\
	[] 0 setdash strokepath} if\n\
    clip\n\
} bind def",
"% desiredSize EvenPixels closestSize",
"%",
"% The procedure below is used for stippling.  Given the optimal size",
"% of a dot in a stipple pattern in the current user coordinate system,",
"% compute the closest size that is an exact multiple of the device's",
"% pixel size.  This allows stipple patterns to be displayed without",
"% aliasing effects.",
"/EvenPixels {\n\
    % Compute exact number of device pixels per stipple dot.\n\
    dup 0 matrix currentmatrix dtransform\n\
    dup mul exch dup mul add sqrt\n\
\n\
    % Round to an integer, make sure the number is at least 1, and compute\n\
    % user coord distance corresponding to this.\n\
    dup round dup 1 lt {pop 1} if\n\
    exch div mul\n\
} bind def",
"% width height string StippleFill --",
"%",
"% Given a path already set up and a clipping region generated from",
"% it, this procedure will fill the clipping region with a stipple",
"% pattern.  \"String\" contains a proper image description of the",
"% stipple pattern and \"width\" and \"height\" give its dimensions.  Each",
"% stipple dot is assumed to be about one unit across in the current",
"% user coordinate system.  This procedure trashes the graphics state.",
"/StippleFill {\n\
    % The following code is needed to work around a NeWSprint bug.\n\
\n\
    /tmpstip 1 index def\n\
\n\
    % Change the scaling so that one user unit in user coordinates\n\
    % corresponds to the size of one stipple dot.\n\
    1 EvenPixels dup scale\n\
\n\
    % Compute the bounding box occupied by the path (which is now\n\
    % the clipping region), and round the lower coordinates down\n\
    % to the nearest starting point for the stipple pattern.  Be\n\
    % careful about negative numbers, since the rounding works\n\
    % differently on them.\n\
\n\
    pathbbox\n\
    4 2 roll\n\
    5 index div dup 0 lt {1 sub} if cvi 5 index mul 4 1 roll\n\
    6 index div dup 0 lt {1 sub} if cvi 6 index mul 3 2 roll\n\
\n\
    % Stack now: width height string y1 y2 x1 x2\n\
    % Below is a doubly-nested for loop to iterate across this area\n\
    % in units of the stipple pattern size, going up columns then\n\
    % across rows, blasting out a stipple-pattern-sized rectangle at\n\
    % each position\n\
\n\
    6 index exch {\n\
	2 index 5 index 3 index {\n\
	    % Stack now: width height string y1 y2 x y\n\
\n\
	    gsave\n\
	    1 index exch translate\n\
	    5 index 5 index true matrix tmpstip imagemask\n\
	    grestore\n\
	} for\n\
	pop\n\
    } for\n\
    pop pop pop pop pop\n\
} bind def",
"% -- AdjustColor --",
"% Given a color value already set for output by the caller, adjusts",
"% that value to a grayscale or mono value if requested by the CL",
"% variable.",
"/AdjustColor {\n\
    CL 2 lt {\n\
	currentgray\n\
	CL 0 eq {\n\
	    .5 lt {0} {1} ifelse\n\
	} if\n\
	setgray\n\
    } if\n\
} bind def",
"% x y strings spacing xoffset yoffset justify stipple DrawText --",
"% This procedure does all of the real work of drawing text.  The",
"% color and font must already have been set by the caller, and the",
"% following arguments must be on the stack:",
"%",
"% x, y -	Coordinates at which to draw text.",
"% strings -	An array of strings, one for each line of the text item,",
"%		in order from top to bottom.",
"% spacing -	Spacing between lines.",
"% xoffset -	Horizontal offset for text bbox relative to x and y: 0 for",
"%		nw/w/sw anchor, -0.5 for n/center/s, and -1.0 for ne/e/se.",
"% yoffset -	Vertical offset for text bbox relative to x and y: 0 for",
"%		nw/n/ne anchor, +0.5 for w/center/e, and +1.0 for sw/s/se.",
"% justify -	0 for left justification, 0.5 for center, 1 for right justify.",
"% stipple -	Boolean value indicating whether or not text is to be",
"%		drawn in stippled fashion.  If text is stippled,",
"%		procedure StippleText must have been defined to call",
"%		StippleFill in the right way.",
"%",
"% Also, when this procedure is invoked, the color and font must already",
"% have been set for the text.",
"/DrawText {\n\
    /stipple exch def\n\
    /justify exch def\n\
    /yoffset exch def\n\
    /xoffset exch def\n\
    /spacing exch def\n\
    /strings exch def\n\
\n\
    % First scan through all of the text to find the widest line.\n\
\n\
    /lineLength 0 def\n\
    strings {\n\
	stringwidth pop\n\
	dup lineLength gt {/lineLength exch def} {pop} ifelse\n\
	newpath\n\
    } forall\n\
\n\
    % Compute the baseline offset and the actual font height.\n\
\n\
    0 0 moveto (TXygqPZ) false charpath\n\
    pathbbox dup /baseline exch def\n\
    exch pop exch sub /height exch def pop\n\
    newpath\n\
\n\
    % Translate coordinates first so that the origin is at the upper-left\n\
    % corner of the text's bounding box. Remember that x and y for\n\
    % positioning are still on the stack.\n\
\n\
    translate\n\
    lineLength xoffset mul\n\
    strings length 1 sub spacing mul height add yoffset mul translate\n\
\n\
    % Now use the baseline and justification information to translate so\n\
    % that the origin is at the baseline and positioning point for the\n\
    % first line of text.\n\
\n\
    justify lineLength mul baseline neg translate\n\
\n\
    % Iterate over each of the lines to output it.  For each line,\n\
    % compute its width again so it can be properly justified, then\n\
    % display it.\n\
\n\
    strings {\n\
	dup stringwidth pop\n\
	justify neg mul 0 moveto\n\
	stipple {\n\
\n\
	    % The text is stippled, so turn it into a path and print\n\
	    % by calling StippledText, which in turn calls StippleFill.\n\
	    % Unfortunately, many Postscript interpreters will get\n\
	    % overflow errors if we try to do the whole string at\n\
	    % once, so do it a character at a time.\n\
\n\
	    gsave\n\
	    /char (X) def\n\
	    {\n\
		char 0 3 -1 roll put\n\
		currentpoint\n\
		gsave\n\
		char true charpath clip StippleText\n\
		grestore\n\
		char stringwidth translate\n\
		moveto\n\
	    } forall\n\
	    grestore\n\
	} {show} ifelse\n\
	0 spacing neg translate\n\
    } forall\n\
} bind def",
"%%EndProlog",
